diff --git a/support/Makefile b/support/Makefile
index bb9889efb4..846e0dbb26 100644
--- a/support/Makefile
+++ b/support/Makefile
@@ -79,8 +79,11 @@ libsupport-routines = \
   support_test_verify_impl \
   temp_file \
   timespec \
+  timespec-time64 \
   timespec-add \
+  timespec-add-time64 \
   timespec-sub \
+  timespec-sub-time64 \
   write_message \
   xaccept \
   xaccept4 \
@@ -90,6 +93,7 @@ libsupport-routines = \
   xchdir \
   xchroot \
   xclock_gettime \
+  xclock_gettime_time64 \
   xclose \
   xchmod \
   xconnect \
@@ -209,6 +213,7 @@ CFLAGS-support_paths.c = \
 # in support_timespec_check_in_range and for that computation we use
 # -fexcess-precision=standard.
 CFLAGS-timespec.c += -fexcess-precision=standard
+CFLAGS-timespec-time64.c += -fexcess-precision=standard
 
 ifeq (,$(CXX))
 LINKS_DSO_PROGRAM = links-dso-program-c
diff --git a/support/timespec-add-time64.c b/support/timespec-add-time64.c
new file mode 100644
index 0000000000..8574e1602c
--- /dev/null
+++ b/support/timespec-add-time64.c
@@ -0,0 +1,27 @@
+/* Add two struct __timespec64 values.  64 bit time support.
+   Copyright (C) 2021 Free Software Foundation, Inc.
+   This file is part of the GNU C Library and is also part of gnulib.
+   Patches to this file should be submitted to both projects.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+#include <time.h>
+
+#if __TIMESIZE != 64
+# define timespec      __timespec64
+# define time_t        __time64_t
+# define timespec_add  timespec_add_time64
+# include "timespec-add.c"
+#endif
diff --git a/support/timespec-add.c b/support/timespec-add.c
index cf8bd91291..8ed3acef6d 100644
--- a/support/timespec-add.c
+++ b/support/timespec-add.c
@@ -61,5 +61,5 @@ timespec_add (struct timespec a, struct timespec b)
         }
     }
 
-  return make_timespec (rs, rns);
+  return (struct timespec) { .tv_sec = rs, .tv_nsec = rns };
 }
diff --git a/support/timespec-sub-time64.c b/support/timespec-sub-time64.c
new file mode 100644
index 0000000000..f88307016d
--- /dev/null
+++ b/support/timespec-sub-time64.c
@@ -0,0 +1,27 @@
+/* Subtract two struct __timespec64 values.  64 bit time support.
+   Copyright (C) 2021 Free Software Foundation, Inc.
+   This file is part of the GNU C Library and is also part of gnulib.
+   Patches to this file should be submitted to both projects.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+#include <time.h>
+
+#if __TIMESIZE != 64
+# define timespec      __timespec64
+# define time_t        __time64_t
+# define timespec_sub  timespec_sub_time64
+# include "timespec-sub.c"
+#endif
diff --git a/support/timespec-sub.c b/support/timespec-sub.c
index 08cc233086..0b8fea042d 100644
--- a/support/timespec-sub.c
+++ b/support/timespec-sub.c
@@ -61,5 +61,5 @@ timespec_sub (struct timespec a, struct timespec b)
         }
     }
 
-  return make_timespec (rs, rns);
+  return (struct timespec) { .tv_sec = rs, .tv_nsec = rns };
 }
diff --git a/support/timespec-time64.c b/support/timespec-time64.c
new file mode 100644
index 0000000000..5bbf8be7e0
--- /dev/null
+++ b/support/timespec-time64.c
@@ -0,0 +1,40 @@
+/* Support code for timespec checks.  64 bit time support.
+   Copyright (C) 2021 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+#include <support/timespec.h>
+#include <stdio.h>
+#include <stdint.h>
+#include <assert.h>
+#include <intprops.h>
+
+#if __TIMESIZE != 64
+struct __timespec64 timespec_sub_time64 (struct __timespec64,
+					 struct __timespec64);
+
+#define test_timespec_before_impl          test_timespec_before_impl_time64
+#define test_timespec_equal_or_after_impl  \
+  test_timespec_equal_or_after_impl_time64
+#define support_timespec_ns                support_timespec_ns_time64
+#define support_timespec_normalize         support_timespec_normalize_time64
+#define support_timespec_check_in_range    \
+  support_timespec_check_in_range_time64
+#define timespec                           __timespec64
+#define timespec_sub                       timespec_sub_time64
+
+#include "timespec.c"
+#endif
diff --git a/support/timespec.c b/support/timespec.c
index b02afad9d3..fcc54861b1 100644
--- a/support/timespec.c
+++ b/support/timespec.c
@@ -23,9 +23,8 @@
 #include <intprops.h>
 
 void
-test_timespec_before_impl (const char *file, int line,
-			   const struct timespec left,
-			   const struct timespec right)
+test_timespec_before_impl (const char *file, int line, struct timespec left,
+			   struct timespec right)
 {
   if (left.tv_sec > right.tv_sec
       || (left.tv_sec == right.tv_sec
@@ -43,8 +42,8 @@ test_timespec_before_impl (const char *file, int line,
 
 void
 test_timespec_equal_or_after_impl (const char *file, int line,
-				   const struct timespec left,
-				   const struct timespec right)
+				   struct timespec left,
+				   struct timespec right)
 {
   if (left.tv_sec < right.tv_sec
       || (left.tv_sec == right.tv_sec
diff --git a/support/timespec.h b/support/timespec.h
index a3eb72aa01..0478aef51f 100644
--- a/support/timespec.h
+++ b/support/timespec.h
@@ -24,11 +24,6 @@
 #include <support/check.h>
 #include <support/xtime.h>
 
-struct timespec timespec_add (struct timespec, struct timespec)
-  __attribute__((const));
-struct timespec timespec_sub (struct timespec, struct timespec)
-  __attribute__((const));
-
 static inline struct timespec
 make_timespec (time_t s, long int ns)
 {
@@ -40,21 +35,54 @@ make_timespec (time_t s, long int ns)
 
 enum { TIMESPEC_HZ = 1000000000 };
 
+#ifndef __USE_TIME_BITS64
+struct timespec timespec_add (struct timespec, struct timespec)
+  __attribute__((const));
+struct timespec timespec_sub (struct timespec, struct timespec)
+  __attribute__((const));
+
 void test_timespec_before_impl (const char *file, int line,
-                                const struct timespec left,
-                                const struct timespec right);
+                                struct timespec left,
+                                struct timespec right);
 
 void test_timespec_equal_or_after_impl (const char *file, int line,
-                                        const struct timespec left,
-                                        const struct timespec right);
+                                        struct timespec left,
+                                        struct timespec right);
 
 time_t support_timespec_ns (struct timespec time);
 
 struct timespec support_timespec_normalize (struct timespec time);
 
-int support_timespec_check_in_range (struct timespec expected, struct timespec observed,
-				  double lower_bound, double upper_bound);
-
+int support_timespec_check_in_range (struct timespec expected,
+				     struct timespec observed,
+				     double lower_bound, double upper_bound);
+
+#else
+struct timespec __REDIRECT (timespec_add, (struct timespec, struct timespec),
+			    timespec_add_time64);
+struct timespec __REDIRECT (timespec_sub, (struct timespec, struct timespec),
+			    timespec_sub_time64);
+void __REDIRECT (test_timespec_before_impl, (const char *file, int line,
+					     struct timespec left,
+					     struct timespec right),
+		 test_timespec_before_impl_time64);
+void __REDIRECT (test_timespec_equal_or_after_impl, (const char *f, int line,
+						     struct timespec left,
+						     struct timespec right),
+		 test_timespec_equal_or_after_impl_time64);
+
+time_t __REDIRECT (support_timespec_ns, (struct timespec time),
+		   support_timespec_ns_time64);
+
+struct timespec __REDIRECT (support_timespec_normalize, (struct timespec time),
+			    support_timespec_normalize_time64);
+
+int __REDIRECT (support_timespec_check_in_range, (struct timespec expected,
+						  struct timespec observed,
+						  double lower_bound,
+						  double upper_bound),
+		support_timespec_check_in_range_time64);
+#endif
 
 /* Check that the timespec on the left represents a time before the
    time on the right. */
diff --git a/support/xclock_gettime_time64.c b/support/xclock_gettime_time64.c
new file mode 100644
index 0000000000..bf9fe9bf9c
--- /dev/null
+++ b/support/xclock_gettime_time64.c
@@ -0,0 +1,26 @@
+/* clock_settime with error checking.  64 bit time_t support.
+   Copyright (C) 2021 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+#include <support/xtime.h>
+
+#if __TIMESIZE != 64
+# define xclock_gettime  xclock_gettime_time64
+# define timespec        __timespec64
+# define clock_gettime   __clock_gettime64
+# include "xclock_gettime.c"
+#endif
diff --git a/support/xtime.h b/support/xtime.h
index 2482837dee..e5fb56a9fc 100644
--- a/support/xtime.h
+++ b/support/xtime.h
@@ -26,7 +26,12 @@ __BEGIN_DECLS
 /* The following functions call the corresponding libc functions and
    terminate the process on error.  */
 
+#ifndef __USE_TIME_BITS64
 void xclock_gettime (clockid_t clock, struct timespec *ts);
+#else
+void __REDIRECT (xclock_gettime, (clockid_t clock, struct timespec *ts),
+		 xclock_gettime_time64);
+#endif
 
 /* This helper can often simplify tests by avoiding an explicit
    variable declaration or allowing that declaration to be const. */